#include<iostream>
#include<queue>
#pragma GCC optimize ("Ofast")
using namespace std;
const int MAX_N=2e3+1;
int n,m;
char t[MAX_N][MAX_N];
int level[MAX_N][MAX_N];
bool used[MAX_N][MAX_N];
pair<int,int>parent[MAX_N][MAX_N];
int sz[MAX_N][MAX_N];
queue<pair<int,int> >q;
int st1,st2;
int en1,en2;
void Read()
{
    cin>>n>>m;
    string s;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            level[i][j]=1e9;
        }
    }
    for(int i=1;i<=n;i++)
    {
        cin>>s;
        for(int j=0;j<m;j++)
        {
            if(s[j]=='+')
            {
                level[i][j+1]=0;
                used[i][j+1]=1;
                q.push({i,j+1});
            }
            if(s[j]=='P')
            {
                st1=i;
                st2=j+1;
            }
            if(s[j]=='C')
            {
                en1=i;
                en2=j+1;
            }
            t[i][j+1]=s[j];
        }
    }
}
void Do(int i,int j,int st)
{
    if(i<1 or i>n or j<1 or j>m)return;
    level[i][j]=min(level[i][j],st+1);
    if(used[i][j])return;
    used[i][j]=1;
    q.push({i,j});
}
void BFS()
{
    while(!q.empty())
    {
        auto cur=q.front();
        q.pop();
        int i=cur.first;
        int j=cur.second;
        Do(i+1,j,level[i][j]);
        Do(i-1,j,level[i][j]);
        Do(i,j+1,level[i][j]);
        Do(i,j-1,level[i][j]);
    }
    /*
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<level[i][j]<<" ";
        }
        cout<<endl;
    }
    */
}
bool Con(int i,int j,int x)
{
    if(i<1 or j<1)return 0;
    if(level[i][j]>=x)return 1;
    return 0;
}
pair<int,int>Find(int i,int j)
{
    if(parent[i][j].first==i && parent[i][j].second==j)return {i,j};
    return parent[i][j]=Find(parent[i][j].first,parent[i][j].second);
}
void Merge(int a,int b,int c,int d)
{
    auto urt=Find(a,b);
    auto vrt=Find(c,d);
    if(sz[urt.first][urt.second]>sz[vrt.first][vrt.second])
    {
        swap(urt,vrt);
    }
    sz[vrt.first][vrt.second]+=sz[urt.first][urt.second];
    parent[urt.first][urt.second]=vrt;
}
vector<pair<int,int> >v[MAX_N][MAX_N];
int comp[MAX_N][MAX_N];
int cmp;
void DFS(int i,int j)
{
    comp[i][j]=cmp;
    for(auto nxt:v[i][j])
    {
        int i1,j1;
        i1=nxt.first;
        j1=nxt.second;
        if(comp[i1][j1]==0)
        {
            DFS(i1,j1);
        }
    }
}
bool Check(int x)
{
    cmp=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            v[i][j].clear();
            comp[i][j]=0;
            parent[i][j]={i,j};
            sz[i][j]=1;
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(level[i][j]>=x)
            {
                if(Con(i-1,j,x))
                {
                    v[i][j].push_back({i-1,j});
                    v[i-1][j].push_back({i,j});
                    //Merge(i,j,i-1,j);
                }
                if(Con(i,j-1,x))
                {
                    v[i][j].push_back({i,j-1});
                    v[i][j-1].push_back({i,j});
                    //Merge(i,j,i,j-1);

                }
            }
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(comp[i][j]==0)
            {
                cmp++;
                DFS(i,j);
            }
        }
    }
    if(comp[st1][st2]==comp[en1][en2])return 1;
    //if(Find(st1,st2)==Find(en1,en2))return 1;
    return 0;
}
void Search()
{
    int l=0,r=n*m;
    int ans;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(Check(mid))
        {
            ans=mid;
            l=mid+1;
        }
        else r=mid-1;
    }
    cout<<ans<<"\n";
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    BFS();
    Search();
    return 0;
}
