#include<iostream>
#include<queue>
#pragma GCC optimize ("Ofast")
using namespace std;
const int MAX_N=2e3+1;
int n,m;
char t[MAX_N][MAX_N];
int level[MAX_N][MAX_N];
bool used[MAX_N][MAX_N];
int parent[MAX_N*MAX_N];
int sz[MAX_N*MAX_N];
int lv;
queue<pair<int,int> >q;
int st1,st2;
int en1,en2;
void Read()
{
    cin>>n>>m;
    string s;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            level[i][j]=1e9;
        }
    }
    for(int i=1;i<=n;i++)
    {
        cin>>s;
        for(int j=0;j<m;j++)
        {
            if(s[j]=='+')
            {
                level[i][j+1]=0;
                used[i][j+1]=1;
                q.push({i,j+1});
            }
            if(s[j]=='P')
            {
                st1=i;
                st2=j+1;
            }
            if(s[j]=='C')
            {
                en1=i;
                en2=j+1;
            }
            t[i][j+1]=s[j];
        }
    }
}
void Do(int i,int j,int st)
{
    if(i<1 or i>n or j<1 or j>m)return;
    level[i][j]=min(level[i][j],st+1);
    if(used[i][j])return;
    used[i][j]=1;
    q.push({i,j});
}
void BFS()
{
    while(!q.empty())
    {
        auto cur=q.front();
        q.pop();
        int i=cur.first;
        int j=cur.second;
        Do(i+1,j,level[i][j]);
        Do(i-1,j,level[i][j]);
        Do(i,j+1,level[i][j]);
        Do(i,j-1,level[i][j]);
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            lv=max(lv,level[i][j]);
        }

    }

}
bool Con(int i,int j,int x)
{
    if(i<1 or j<1)return 0;
    if(level[i][j]>=x)return 1;
    return 0;
}
int Find(int u)
{
    if(parent[u]==u)return u;
    return parent[u]=Find(parent[u]);
}
void Merge(int u,int v)
{
    int urt=Find(u);
    int vrt=Find(v);
    if(sz[urt]>sz[vrt])
    {
        swap(urt,vrt);
    }
    sz[vrt]+=sz[urt];
    parent[urt]=vrt;
}
//vector<int >v[MAX_N*MAX_N];
//int comp[MAX_N*MAX_N];
//int cmp;
/*void DFS(int u)
{
    comp[u]=cmp;
    for(int nxt:v[u])
    {
        if(comp[nxt]==0)
        {
            DFS(nxt);
        }
    }
}
*/
bool Check(int x)
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            parent[i*(n-1)+j]=i*(n-1)+j;
            sz[i*(n-1)+j]=1;
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(level[i][j]>=x)
            {
                if(Con(i-1,j,x))
                {
                    //v[i*(n-1)+j].push_back((i-1)*(n-1)+j);
                    //v[(i-1)*(n-1)+j].push_back(i*(n-1)+j);
                    Merge(i*(n-1)+j,(i-1)*(n-1)+j);
                }
                if(Con(i,j-1,x))
                {
                    //v[i*(n-1)+j].push_back(i*(n-1)+j-1);
                    //v[i*(n-1)+j-1].push_back(i*(n-1)+j);
                    Merge(i*(n-1)+j,i*(n-1)+j-1);

                }
            }
        }
    }
    /*
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(comp[i*(n-1)+j]==0)
            {
                cmp++;
                DFS(i*(n-1)+j);
            }
        }
    }
    */
    //if(comp[st1*(n-1)+st2]==comp[en1*(n-1)+en2])return 1;
    if(Find(st1*(n-1)+st2)==Find(en1*(n-1)+en2))return 1;
    return 0;
}
void Search()
{
    int l=0,r=lv;
    int ans;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(Check(mid))
        {
            ans=mid;
            l=mid+1;
        }
        else r=mid-1;
    }
    cout<<ans<<"\n";
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    BFS();
    Search();
    return 0;
}
