#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2048;
const long long inf = 1e9;
int n, m, a[maxn][maxn], used[maxn][maxn];
int u[maxn][maxn];
char c[maxn][maxn];

struct cell{
    int x, y;

    cell operator+(cell p){
        return {x + p.x, y + p.y};
    }
    bool inRange(){
        return x >= 1 && x <= n && y >= 1 && y <= m;
    }
};

queue<cell> q;
cell P, C, dir[4] = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

void read(){
    cin >> n >> m;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= m;j++){
            cin >> c[i][j];
            if(c[i][j] == '+'){
                used[i][j] = 1;
                q.push({i, j});
            }
            else if(c[i][j] == 'P'){
                P = {i, j};
            }
            else if(c[i][j] == 'C'){
                C = {i, j};
            }
        }
    }
}

void bfs(){
    while(!q.empty()){
        cell t = q.front(); q.pop();
        for(int i = 0;i < 4;i++){
            cell curr = t + dir[i];
            if(curr.inRange() && !used[curr.x][curr.y]){
                used[curr.x][curr.y] = used[t.x][t.y] + 1;
                q.push(curr);
            }
        }
    }
}

bool check(int T){
    if(used[P.x][P.y] < T) return false;
    queue<cell> q;
    q.push(P);
    memset(u, 0, sizeof(u));
    u[P.x][P.y] = 1;
    while(!q.empty()){
        cell t = q.front();
        q.pop();
        for(int i = 0;i < 4;i++){
            cell curr = t + dir[i];
            if(curr.inRange() && !u[curr.x][curr.y] && used[curr.x][curr.y] >= T){
                if(curr.x == C.x && curr.y == C.y) return true;
                u[curr.x][curr.y] = 1;
                q.push(curr);
            }
        }
    }
    return false;
}

void solve(){
    int bord = 0;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= m;j++){
            used[i][j]--;
            bord = max(bord, used[i][j]);
        }
    }
    int l = 1, r = bord, ans = 0;
    while(l <= r){
        int mid = (l + r) / 2;
        if(check(mid)) l = mid + 1, ans = mid;
        else r = mid - 1;
    }
    cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    bfs();
    solve();
    return 0;
}
