#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2005;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m;
char a[MAXN][MAXN];

struct cell
{
    int x, y;
    cell(){};
    cell(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
    cell operator+(cell w)
    {
        cell ans = cell(x + w.x, y + w.y);
        return ans;
    }
    bool in_range()
    {
        return(x >= 1 && x <= n && y >= 1 && y <= m);
    }
};

cell st, fi;
cell dir[4]{{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

vector < cell > v;

void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
            if(a[i][j] == '+')v.push_back(cell(i, j));
            else if(a[i][j] == '.')continue;
            else if(a[i][j] == 'P')st = cell(i, j);
            else if(a[i][j] == 'C')fi = cell(i, j);
        }
    }
}
int dist[MAXN][MAXN];
void init_dist()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            dist[i][j] = 1e9;
    }
}

int used[MAXN][MAXN];

void bfs()
{
    memset(used, 0, sizeof(used));
    queue < cell > q;
    for (int i = 0; i <v.size(); ++ i)
    {
        q.push(v[i]);
        dist[v[i].x][v[i].y] = 0;
        used[v[i].x][v[i].y] = 1;
    }
    cell w, nb;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        for (int i = 0; i < 4; ++ i)
        {
            nb = w + dir[i];
            if(nb.in_range() && !used[nb.x][nb.y] )
            {

                    dist[nb.x][nb.y] = dist[w.x][w.y] + 1;
                    used[nb.x][nb.y] = 1;
                    q.push(nb);
            }

        }
    }
}
void fill_dist()
{
    init_dist();
    bfs();
/*
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            cout << dist[i][j] << " ";
        cout << endl;
    }
*/
}
bool check(int x)
{
    //x --;
    ///if(x == 3)cout << "here" << endl;
    memset(used, 0, sizeof(used));
    queue < cell > q;
    q.push(st);
    used[st.x][st.y] = 1;
    if(dist[st.x][st.y] < x)return false;
    cell w, nb;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        for (int i = 0; i < 4; ++ i)
        {
            nb = dir[i] + w;
            if(!nb.in_range())
            {
                continue;
            }
            if(nb.x == fi.x && nb.y == fi.y)return true;
            if(!used[nb.x][nb.y] && dist[nb.x][nb.y] >= x)
            {
                used[nb.x][nb.y] = 1;
                if(nb.x == fi.x && nb.y == fi.y)return true;
                q.push(nb);
            }
        }
    }
    return false;
}
void bin_search()
{
    int left = 0, right = dist[st.x][st.y], ans = 0, mid;
    while(left <= right)
    {
        mid = (left + right)/2;
        if(check(mid))
        {
            ans = mid;
            left = mid + 1;
        }
        else right = mid - 1;
    }
    cout << ans << endl;
}
int main()
{
    speed();

    read();
    fill_dist();
    bin_search();
}
/**
4 4
P...
+..+
..C+
+...
*/
